﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Runtime.InteropServices;

namespace smplCs
{
    public partial class Form1 : Form
    {
    	// For Dll Start
		//	Board Type
    	private const UInt16	AW_TYPE_AP4801 = 0x0020;
    	private const UInt16	AW_TYPE_AP4802 = 0x0021;

		//	Read/Write/Size
		private const UInt32	FLG_READ = 0x00000000;
		private const UInt32	FLG_WRITE = 0x00000001;
		private const UInt32	FLG_READ_WRITE_MASK = 0x00000001;

		private const UInt32	FLG_BYTE = 0x00000000;
		private const UInt32	FLG_WORD = 0x00000002;
		private const UInt32	FLG_BYTE_WORD_MASK = 0x00000002;

		private const UInt32	FLG_READ_BYTE = FLG_READ | FLG_BYTE;
		private const UInt32	FLG_WRITE_BYTE = FLG_WRITE | FLG_BYTE;
		private const UInt32	FLG_READ_WORD = FLG_READ | FLG_WORD;
		private const UInt32	FLG_WRITE_WORD = FLG_WRITE | FLG_WORD;

    	//   Structure  AW_DEVICE_LIST
    	public struct AW_DEVICE_INFO {
        	public UInt16 BoardNo;
        	public UInt16 BoardType;
        	public UInt32 MemSize;
    	}
    	public struct AW_DEVICE_LIST {
        	public UInt32 BoardCount;
        	public AW_DEVICE_INFO[] DeviceInfo; 
    	}

    	//   GetDeviceInfo
    	[DllImport("AW_DB_A40_PCI.dll", CallingConvention=CallingConvention.Cdecl)]
    	private extern static int AW_GetDeviceInfo( ref AW_DEVICE_LIST AwDeviceList);

	    //   GetBoardCount
    	[DllImport("AW_DB_A40_PCI.dll", CallingConvention=CallingConvention.Cdecl)]
        private extern static int AW_GetBoardCount( ref UInt32 BoardCount );

    	//   Get1DeviceInfo
    	[DllImport("AW_DB_A40_PCI.dll", CallingConvention=CallingConvention.Cdecl)]
        private extern static int AW_Get1DeviceInfo( UInt16 BoardNo, ref UInt16 BoardType, ref UInt32 MemSize);

    	//   Read Byte
    	[DllImport("AW_DB_A40_PCI.dll", CallingConvention=CallingConvention.Cdecl)]
    	private extern static int AW_ReadByte(int BoardNo, UInt32 Address, ref Byte ByteData);

    	//   Read Word
    	[DllImport("AW_DB_A40_PCI.dll", CallingConvention=CallingConvention.Cdecl)]
    	private extern static int AW_ReadWord(int BoardNo, UInt32 Address, ref UInt16 WordData);

    	//   Write Byte
    	[DllImport("AW_DB_A40_PCI.dll", CallingConvention=CallingConvention.Cdecl)]
    	private extern static int AW_WriteByte(int BoardNo, UInt32 Address, Byte ByteData);

    	//   Write Word
    	[DllImport("AW_DB_A40_PCI.dll", CallingConvention=CallingConvention.Cdecl)]
    	private extern static int AW_WriteWord(int BoardNo, UInt32 Address, UInt16 WordData);
    	// For Dll End

		//	Class Valiable
    	public AW_DEVICE_LIST	gDeviceList;
		public int				gBoardNo;
		public UInt32			gAddress;
		public Byte				gBData;
		public UInt16			gWData;
		public int				gRet;

        public Form1()
        {
            InitializeComponent();
        }

        private void btnGetDeviceInfo_Click(object sender, EventArgs e)
        {
            UInt16      InfoIdx;
            UInt16      BoardType = 0;
            UInt32      MemSize = 0;

            if (AW_GetBoardCount(ref gDeviceList.BoardCount) < 0) {             // Get BoardCount
                return;
            }

            if (gDeviceList.BoardCount == 0) {
                return;
            }

            gDeviceList.DeviceInfo = new AW_DEVICE_INFO[gDeviceList.BoardCount];          // Get DeviceInfo Area

            InfoIdx = 0;
            for ( UInt16 i = 0; i < 16; i++ ) {
                if (AW_Get1DeviceInfo(i, ref BoardType, ref MemSize) < 0) {
                    return;
                }
                if ((BoardType == AW_TYPE_AP4801) || (BoardType == AW_TYPE_AP4802)) {
                    gDeviceList.DeviceInfo[InfoIdx].BoardNo = i;
                    gDeviceList.DeviceInfo[InfoIdx].BoardType = BoardType;
                    gDeviceList.DeviceInfo[InfoIdx].MemSize = MemSize;
                    InfoIdx += 1;
                }
            }

            cbxBoardNo.Items.Clear();
            for ( UInt16 i = 0; i < gDeviceList.BoardCount; i++ ) {
                cbxBoardNo.Items.Add(Convert.ToString(gDeviceList.DeviceInfo[i].BoardNo, 16));
            }

            btnGetDeviceInfo.Enabled = false;
            btnReadByte.Enabled = true;
            btnWriteByte.Enabled = true;
            btnReadWord.Enabled = true;
            btnWriteWord.Enabled = true;
            tbxAddress.Enabled = true;
            tbxData.Enabled = true;
            tbxRtnv.Enabled = true;

            cbxBoardNo.SelectedIndex = 0;
            cbxBoardNo.Enabled = true;

            //cbxBoardNo_SelectionChangeCommitted(Nothing, Nothing);

            //AW_DEVICE_LIST DeviceList;

            //int Count = AW_GetDeviceInfo( ref gDeviceList );
        }

    	// button ReadByte
        private void btnReadByte_Click(object sender, EventArgs e)
        {
			//int		Ret;

			GetInputParam( FLG_READ_BYTE );

			gRet = AW_ReadByte( gBoardNo, gAddress, ref gBData );

			SetResultParam( FLG_READ_BYTE );

        }

    	// button WriteByte
        private void btnWriteByte_Click(object sender, EventArgs e)
        {
			//int		Ret;

			GetInputParam( FLG_WRITE_BYTE );

			gRet = AW_WriteByte( gBoardNo, gAddress, gBData );

			SetResultParam( FLG_WRITE_BYTE );

        }

    	// button ReadWord
        private void btnReadWord_Click(object sender, EventArgs e)
        {
			//int		Ret;

			GetInputParam( FLG_READ_WORD );

			gRet = AW_ReadWord( gBoardNo, gAddress, ref gWData );

			SetResultParam( FLG_READ_WORD );

        }

    	// button WriteWord
        private void btnWriteWord_Click(object sender, EventArgs e)
        {
			//int		Ret;

			GetInputParam( FLG_WRITE_WORD );

			gRet = AW_WriteWord( gBoardNo, gAddress, gWData );

			SetResultParam( FLG_WRITE_WORD );

        }

    	// button Exit
        private void btnExit_Click(object sender, EventArgs e)
        {
        	Application.Exit();
        }

    	// button WriteWord
        private void cbxBoardNo_SelectedIndexChanged(object sender, EventArgs e)
        {
        	int		i;

        	i = cbxBoardNo.SelectedIndex;
        	if (i >= 0) {
            	String		str;
            	switch (gDeviceList.DeviceInfo[i].BoardType) {
                	case AW_TYPE_AP4801:
                    	str = "AP48-01";
						break;
                	case AW_TYPE_AP4802:
                    	str = "AP48-02";
						break;
                	default:
                    	str = "unknown";
						break;
            	}
            	lblBoardName.Text = str;
        	}
        	//lblAdrRange.Text = "0x0000-0x" & Convert.ToString(gDeviceList.DeviceInfo(i).MemSize, 16).PadLeft(4, "0")
        	// 本当は -1 なのだが...
        	lblAdrRange.Text = "0x0000-0x" + String.Format("{0:X4}", gDeviceList.DeviceInfo[i].MemSize );
        }

		// Get Input Param
    	private void GetInputParam( UInt32 Flg ) {
        	int		i;

        	i = cbxBoardNo.SelectedIndex;
        	gBoardNo = gDeviceList.DeviceInfo[i].BoardNo;

			if (System.Text.RegularExpressions.Regex.IsMatch(tbxAddress.Text, "^[0-9A-Fa-f]+$")) {			// check input Text HEX
        		gAddress = Convert.ToUInt32(tbxAddress.Text, 16);
			} else {
        		gAddress = 0;
			}
        	tbxAddress.Text = String.Format("{0:X4}", gAddress );

        	if ((Flg & FLG_READ_WRITE_MASK) == FLG_WRITE) {
            	if ((Flg & FLG_BYTE_WORD_MASK) == FLG_BYTE) {
					if (System.Text.RegularExpressions.Regex.IsMatch(tbxData.Text, "^[0-9A-Fa-f]+$")) {		// check input Text HEX
                		gBData = Convert.ToByte(tbxData.Text, 16);
					} else {
                		gBData = 0;
					}
                	tbxData.Text = String.Format("{0:X2}", gBData);
            	} else {
					if (System.Text.RegularExpressions.Regex.IsMatch(tbxData.Text, "^[0-9A-Fa-f]+$")) {		// check input Text HEX
                		gWData = Convert.ToUInt16(tbxData.Text, 16);
					} else {
                		gWData = 0;
					}
                	tbxData.Text = String.Format("{0:X4}", gWData);
            	}
        	}

    	}

    	// Set Result Param
    	private void SetResultParam( UInt32 Flg ) {

			tbxRtnv.Text = String.Format("{0:d}", gRet);

        	if ((Flg & FLG_READ_WRITE_MASK) == FLG_READ) {
            	if ((Flg & FLG_BYTE_WORD_MASK) == FLG_BYTE) {
                	tbxData.Text = String.Format("{0:X2}", gBData);
            	} else {
                	tbxData.Text = String.Format("{0:X4}", gWData);
            	}
        	}

    	}

    }
}
